<?php
/**
 * Project:     Open Auto Classifieds link parser
 * File:        function.parse_sef_links.php
 * Author:      Brandon Keep
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Example Usage : Place the {parse_sef_links url="url"} in your existing <a href="<==>">links</a>
 * <a href="{parse_sef_links url="listings.php?action=view&id=5&sort=asc"}">Link Text</a>
 * returns -> listings/action/view/id/5/sort/asc/ if fancy links are turned on
 * or
 * returns -> listings.php?action=view&id=5&sort=asc if fancy links are turned off
 * You will still have to modify your mod_rewrite rules as needed.
 */

function smarty_function_parse_sef_links($params, &$smarty)
{
	global $use_fancy_urls;

    $_id = 'default';
    $_attrs = array();
	$this_query_string = '';

	if ($params["url"]) {
		$this_url = str_replace('&amp;', '&', $params["url"]);
		$this_url = str_replace('&', '&amp;', $this_url);
		if (preg_match('!^[\w -]+(\.[^?]+)$!', $this_url)) {
			return $this_url;
		} else {
			$this_url_array = explode('?', $this_url);
		}

		$query_string_array = explode('&amp;', $this_url_array[1]);
		list($url_base,$ext) = explode('.', $this_url_array[0], 2);
		if ($use_fancy_urls) {
			foreach ($query_string_array as $keys => $values) {
				$values = explode('=', $values);
				$this_query_string .= "$values[0]/$values[1]/";
			}

			$_ret = "$url_base/$this_query_string";
			//returns output -> listings/action/view/id/5/sort/asc/
			return $_ret;
		} else {
			//for some reason I built this section to do nothing oops I will remove it later
			//foreach ($query_string_array as $key => $value) {
				//$value = explode('=', $value);
				//$query_string .= "$value[0]=$value[1]&amp;";
			//}

			//$this_query_string = substr($query_string, 0, -5);
			//$_ret = "$url_base.$ext?$this_query_string";
			//returns output -> listings.php?action=view&id=5&sort=asc
			$_ret = "$this_url";
			return $_ret;
    	}
	}
}

?>