<?php
//================================================================================
// PLEASE DO NOT REMOVE THIS HEADER!!!
//
// COPYRIGHT NOTICE
// This script is licensed under the GPL
// 
// Copyright 2007-2008 Alias 454 Studios and Brandon Keep (c) All rights reserved.
// Created 11/18/2007   
// Brandon Keep,    http://www.openautoclassifieds.com
//                  http://www.alias454studios.com/scripts/
//
// Last Modified 06-14-2009 by
// Brandon Keep,    http://alias454studios.com
//================================================================================
// This software IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
// OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
//================================================================================

require_once './Includes/configs/functions.php';
require_once './Includes/libs/Smarty.class.php';

if (file_exists("./Includes/language/$site_lang/global.php")) {
	include_once "./Includes/language/$site_lang/global.php";
} else {
	include_once "./Includes/language/en/global.php";
}
if (file_exists("./Includes/language/$site_lang/".basename(__FILE__)."")) {
	include_once "./Includes/language/$site_lang/".basename(__FILE__)."";
}

$smarty = new Smarty;
$smarty->force_compile = $force_compile_enabled;

$file = basename(__FILE__, ".php");
if (file_exists("templates/$template/$file.tpl")) {
	$smarty->template_dir="templates/$template";
} else {
	$smarty->template_dir="templates/Default";
}

$smarty->assign("manufacturerslist",getSearchList("make"));
$smarty->assign("modelslist",getSearchList("model"));
$smarty->assign("typeslist",getSearchList("vehicle_type"));

//if the user is logged in let them be else redirect them to login
if (isset($_SESSION["logged_in"])) {
	$smarty->assign("logged_in",1);
	$smarty->assign("username",$_SESSION["user"]);
	//check privs to find out if user 
	//is a seller, admin or user
	$status = checkPrivs();
	$smarty->assign("$status",1);

	if (checkIfAdmin($_SESSION["user"],$_SESSION["pass"]) || checkIfSeller($_SESSION["user"],$_SESSION["pass"])) {
		if (isset($_POST["submit"]) && $_POST["submit"] == ADD_LISTING_FORM_SUBMIT_BUTTON) {
			$_POST = codeClean($_POST);
			if (!empty($_POST["features"])) {
				$implodedfeatures = implode(',', $_POST["features"]);
			} else {
				$implodedfeatures = "";
			}

			if (!empty($_POST["seller"])) {
				$sellerid = getSellerId($_POST["seller"]);

				$success = '';
				$error_message = '';
				$lastlistingid = '';
				$res = addListing($_POST["ad_title"],$_POST["make"],$_POST["model"],$_POST["vehicle_type"],$_POST["doors"],$_POST["color"],$_POST["mileage"],$_POST["year"],$_POST["listing_condition"],$_POST["engine"],$_POST["trans"],$_POST["drive_train"],$_POST["mpg"],$_POST["fuel_type"],$_POST["price"],$_POST["adddesc"],$implodedfeatures,$_POST["vin"],$_POST["stock"],$_POST["city"],$_POST["state"],$_POST["zip"],$sellerid,$_POST["seller"]);
				if (!is_array($res) && $res > 99) {
					//add listing data was a success now add images if files
					$success .= ADD_LISTING_SUCCESS ."<br />";
					//image functions if listing was successful
					$lastlistingid = $res-99;
					
					//if files array not empty perform upload operations
					if (!empty($_FILES["image"])) {
						//$_FILES = codeClean($_FILES);
	
						//break down file array so we get the right info
						$image_files = array(); 
						foreach ($_FILES["image"] as $field => $array) {
							foreach ($array as $a_num => $value) {
								//print "$array -- $a_num -- $field -- $value <br />";
								if (!array_key_exists($a_num, $image_files))
									$image_files["$a_num"] = array();
						
								$image_files["$a_num"]["$field"] = $value;
							}
						}
	
						//we have a proper file array loop through adding the listimages and return errors
						foreach ($image_files as $file_info) {
							if (!empty($file_info["name"])) {
								$res = uploadListImage($listings_stored_path, $file_info["name"], $file_info["tmp_name"], $_POST["max"], $lastlistingid, "listing_", $_SESSION["user"]);
								if ($res == 99) {
									$success = preg_replace("!%FILENAME%!",$file_info["name"], ADD_LISTING_UPLOAD_SUCCESS . "<br />");
								} elseif ($res == 1) {
									$error_message = preg_replace("!%MAXFILESIZE%!",$_POST["max"]/1024, ADD_LISTING_MAX_ERROR);
									$error_message = preg_replace("!%FILENAME%!",$file_info["name"], "$error_message <br />");
								} elseif ($res == 2) {
									$error_message .= ADD_LISTING_BAD_EXT . "<br />";
								} else {
									$error_message = preg_replace("!%FILENAME%!",$file_info["name"], ADD_LISTING_UPLOAD_ERROR . "<br />");
								}
							}
						}
					}
	
					//if error or success from image res display message in template
					if (isset($error_message)) {
						$smarty->assign("error_message",$error_message);
					}
					if (isset($success)) {
						$smarty->assign("success",$success);
					}

					if (!empty($use_listing_approval)) {
						if ($use_new_listing_admin_email) {
							//send email on success to admin
							//setup email variables
							$to_email = $admin_email;
							$from_name = $admin_name;
							$from_email = $admin_email;
							
							//build email from global lang file for listing notification
							$subject = NEW_LISTING_CREATION_EMAIL_SUBJECT;
							$body = NEW_LISTING_CREATION_EMAIL_BODY;
				
							sendEmail($to_email,$subject,$body,$from_name,$from_email);
						}
					}
				} else {
					//there was an error redo post saved text
					$smarty->assign("ad_title",$_POST["ad_title"]);
					$smarty->assign("make",$_POST["make"]);
					$smarty->assign("model",$_POST["model"]);
					$smarty->assign("vehicle_type",$_POST["vehicle_type"]);
					$smarty->assign("doors",$_POST["doors"]);
					$smarty->assign("color",$_POST["color"]);
					$smarty->assign("mileage",$_POST["mileage"]);
					$smarty->assign("year",$_POST["year"]);
					$smarty->assign("listing_condition",$_POST["listing_condition"]);
					$smarty->assign("engine",$_POST["engine"]);
					$smarty->assign("trans",$_POST["trans"]);
					$smarty->assign("drive_train",$_POST["drive_train"]);
					$smarty->assign("mpg",$_POST["mpg"]);
					$smarty->assign("fuel_type",$_POST["fuel_type"]);
					$smarty->assign("price",$_POST["price"]);
					$smarty->assign("adddesc",$_POST["adddesc"]);
					//$smarty->assign("postfeatures",isset($_POST["features"]));
					$smarty->assign("vin",$_POST["vin"]);
					$smarty->assign("stock",$_POST["stock"]);
					$smarty->assign("city",$_POST["city"]);
					$smarty->assign("state",$_POST["state"]);
					$smarty->assign("zip",$_POST["zip"]);
					$smarty->assign("sellerid",$_POST["sellerid"]);
					
					//Errors during form submission	so build error list
					$content = '';
					if (in_array(1,$res)) {
						$content .= "" . EMPTY_MAKE ."<br />";
						$smarty->assign("manufacturer_error",1);
					}
					if (in_array(2,$res)) {
						$content .= "" . EMPTY_MODEL ."<br />";
						$smarty->assign("model_error",1);
					} 
					if (in_array(3,$res)) {
						$content .= "" . MILEAGE_ERROR ."<br />";
						$smarty->assign("mileage_error",1);
					} 
					if (in_array(4,$res)) {
						$content .= "" . YEAR_LENGTH_ERROR ."<br />";
						$smarty->assign("year_error",1);
					}
					if (in_array(5,$res)) {
						$content .= "" . YEAR_DIGIT_ERROR ."<br />";
						$smarty->assign("year_error",1);
					}
					if (in_array(6,$res)) {
						$content .= "" . VIN_LENGTH_ERROR ."<br />";
						$smarty->assign("vin_error",1);
					}
					if (in_array(7,$res)) {
						$content .= "" . VIN_INVALID_ERROR ."<br />";
						$smarty->assign("vin_error",1);
					}
					
					$smarty->assign("error_message",$content);
				}
			} else {
				//no default seller setup post error 
				$smarty->assign("error_message",NO_DEFAULT_SELLER);
			}
		}

		$smarty->assign("fullmanufacturerslist",getTableDataList('manufacturer'));
		$smarty->assign("drivetrainlist",getTableDataList('drive_train'));
		$smarty->assign("typeslist",getTableDataList('vehicle_type'));
		$smarty->assign("featurelist",getFeaturesList());
		$smarty->assign("userdetails",getUserRecords($_SESSION["user"]));
		$smarty->assign("sellerslist",getSellers());
		$smarty->assign("stateslist",getStatesList());
		//$smarty->assign("max_image_count",$max_listing_image_limit);
		$smarty->assign("max_image_count",3);

	} else {
		header("Location: member.php");
		exit();
	}
} else {
	header("Location: login.php");
	exit();
}

$smarty->assign("addlisting",1);
$smarty->display('addlisting.tpl');
?>