<?php
//================================================================================
// PLEASE DO NOT REMOVE THIS HEADER!!!
//
// COPYRIGHT NOTICE
// This script is licensed under the GPL
// 
// Copyright 2007-2008 Alias 454 Studios and Brandon Keep (c) All rights reserved.
// Created 11/18/2007   
// Brandon Keep,    http://www.openautoclassifieds.com
//                  http://www.alias454studios.com/scripts/
//
// Last Modified 06-15-2009 by
// Brandon Keep,    http://alias454studios.com
//================================================================================
// This software IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
// OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
//================================================================================

require_once 'Includes/configs/admin_config.php';
if (file_exists("./Includes/language/$site_lang/admin_global.php")) {
	include_once "./Includes/language/$site_lang/admin_global.php";
} else {
	include_once "./Includes/language/en/admin_global.php";
}
if (file_exists("../Includes/language/$site_lang/global.php")) {
	include_once "../Includes/language/$site_lang/global.php";
} else {
	include_once "../Includes/language/en/global.php";
}
if (file_exists("./Includes/language/$site_lang/".basename(__FILE__)."")) {
	include_once "./Includes/language/$site_lang/".basename(__FILE__)."";
} else {
	include_once "./Includes/language/en/".basename(__FILE__)."";
}

//Get the result of the query as a csv
function csvExport($table, $headers) 
{
	$file_out = '';
	$current_date = date("Y-m-d");
	$filename = "Backup-table-$table-$current_date.csv";

	if (!empty($headers)) {
		$sql = "SHOW COLUMNS FROM $table";
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		$num = sqlNumRows($res);

		while ($row = sqlFetchAssoc($res)) {
			$file_out .="\"$row[Field]\",";
		}
		$file_out .="\n";
	}

	$sql = "SELECT * FROM $table";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	while ($row = sqlFetchAssoc($res)) {
		foreach ($row as $data) {
			$file_out .="\"$data\",";
		}
		$file_out .="\n";
	}

	$out = strlen($file_out);
	if (isset($file_out)) {
		header("Content-Length: $out");
		header("Content-type: application/csv");
		header("Content-Disposition: attachment; filename=$filename");
		echo $file_out;
		exit;
	}
	return false;
}

//Import the contents of a csv file after uploading it
function csvImport($dbname, $csv_file, $csv_temp_file, $max_size)
{
	if (!$csv_file)
		return 1; //return "no file error on ".__FILE__.",".__LINE__ ."";

	//get list of tables names so we can use them for a check later
	$sql = "SHOW TABLES FROM $dbname";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	$tables = array();
	while($a_row = sqlFetchAssoc($res)) {
		$tables[] = $a_row['Tables_in_' . $dbname];
	}

	$csv_file_array = explode('-', $csv_file);
	$table = $csv_file_array[2];

	if (!in_array($table, $tables))
		return 2; //return "file name wrong formate error on ".__FILE__.",".__LINE__ ."";

	$handle = fopen($csv_temp_file,'r');
	if (!$handle) 
		return 3; //return "file handle error on ".__FILE__.",".__LINE__ ."";

	$fields = fgets($handle);
	$fields = str_replace('"', '`', $fields);
	$fields = substr($fields, 0, -2);
	
	$sql = "INSERT INTO $table ($fields) VALUES (";

    //Read the file as csv
	$query_string = '';
	$row_count = 0;
	while (($data = fgetcsv($handle)) !== false) {
		++$row_count;
		foreach ($data as $key => $value) {
			$clean_data = sqlEscapeString((get_magic_quotes_gpc())? stripslashes($value): $value);
			$query_string .= "'" . $clean_data . "',";
		}
		$query_string = substr($query_string, 0, -4);
		$query_string .="),(";
	}
	$sql .= substr($query_string, 0, -3);
	$sql .= ")";
	//$sql = str_replace("''", "'NULL'", $sql);
	fclose($handle);

	if (!empty($sql)) {
		//some records were found drop entire table then re insert the uploaded table data,
		$del = "TRUNCATE TABLE $table";
		$del_res = sqlQuery($del); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

		if (!empty($row_count)) 
			return ($row_count +5); //return 'Successfully imported '.$count.' record(s)';
		
	} else {
		return 4; //return 'Cannot import data - no records found on ".__FILE__.",".__LINE__ ."";
	}
}

$smarty = new Smarty;

//User not an administrator, redirect to main login page automatically.
if (!checkIfAdmin($_SESSION["user"],$_SESSION["pass"])) {
	header("Location: ../login.php");
	exit();
} else{		
	//check if logged in
	if (isset($_SESSION["logged_in"])) {
		session_regenerate_id();
		$smarty->assign("logged_in",1);
		$smarty->assign("username",$_SESSION["user"]);
	}

	if (checkIfAdmin($_SESSION["user"],$_SESSION["pass"])) {
		session_regenerate_id();
		$_SESSION["admin"] = 1;

		//Administrator is viewing page, so display all
		if (isset($_SESSION["admin"])) {
			$smarty->assign("admin",1);
			//csvExport($table, headers)
			if (isset($_POST["getcsv"]) && $_POST["getcsv"] == SUBMIT) {
				$_POST = codeClean($_POST);
				
				if (!empty($_POST["csv_table_name"])) {
					$res = csvExport($_POST["csv_table_name"],$_POST["use_headers"]);
					if (!isset($res)) {
						$smarty->assign("error_message",CSV_EXPORT_ERROR);
					}
				} else {
					$smarty->assign("error_message",CSV_TABLE_SELECT_ERROR);
				}
			}

			//csvImport($csv_file, $csv_temp_file, $max_size)
			if (isset($_POST["addcsv"])) {
				$_POST = codeClean($_POST);
				$_FILES = codeClean($_FILES);
				$res = csvImport($dbname,$_FILES["csv_file"]["name"], $_FILES["csv_file"]["tmp_name"], $_POST["max"], $_SESSION["user"]);
				if ($res > 5) {
					$count = ($res-5);
					$smarty->assign("success",CSV_UPLOAD_SUCCESS);
				} elseif ($res == 1) {
					$smarty->assign("error_message",CSV_UPLOAD_FILE_ERROR);
				} elseif ($res == 2) {
					$smarty->assign("error_message",CSV_UPLOAD_FILE_NAME_ERROR);
				} elseif ($res == 3) {
					$smarty->assign("error_message",CSV_VALID_FILE_ERROR);
				} elseif ($res == 4) {
					$smarty->assign("error_message",CSV_EMPTY_ROWS_ERROR);
				}
			}
		}
	}
}

$smarty->assign("maintenance",1);
$smarty->display('maintenance.tpl');
?>