<?php
//================================================================================
// PLEASE DO NOT REMOVE THIS HEADER!!!
//
// COPYRIGHT NOTICE
// This script is licensed under the GPL
// 
// Copyright 2007-2008 Alias 454 Studios and Brandon Keep (c) All rights reserved.
// Created 11/18/2007   
// Brandon Keep,    http://www.openautoclassifieds.com
//                  http://www.alias454studios.com/scripts/
//
// Last Modified 01-05-2009 by
// Brandon Keep,    http://alias454studios.com
//================================================================================
// This software IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
// OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
//================================================================================

require_once 'Includes/configs/admin_config.php';
if (file_exists("./Includes/language/$site_lang/admin_global.php")) {
	include_once "./Includes/language/$site_lang/admin_global.php";
} else {
	include_once "./Includes/language/en/admin_global.php";
}
if (file_exists("../Includes/language/$site_lang/global.php")) {
	include_once "../Includes/language/$site_lang/global.php";
} else {
	include_once "../Includes/language/en/global.php";
}
if (file_exists("./Includes/language/$site_lang/".basename(__FILE__)."")) {
	include_once "./Includes/language/$site_lang/".basename(__FILE__)."";
} else {
	include_once "./Includes/language/en/".basename(__FILE__)."";
}

$smarty = new Smarty;

//User not an administrator, redirect to main login page automatically.
if (!checkIfAdmin($_SESSION["user"],$_SESSION["pass"])) {
	header("Location: ../login.php");
	exit();
} else {
	//check that your logged in
	if (isset($_SESSION["logged_in"])) {
		session_regenerate_id();
		$smarty->assign("logged_in",1);
		$smarty->assign("username",$_SESSION["user"]);
	}
	
	if (checkIfAdmin($_SESSION["user"],$_SESSION["pass"])) {
		$_SESSION["admin"] = 1;
		
		//Administrator is viewing page, so display all
	   	if (isset($_SESSION["admin"])) {
   		   	$smarty->assign("admin",1);

			//if single option edit get data then display form
			if (!empty($_GET["action"]) && $_GET["action"] == "editsingle") {
				$smarty->assign("editsingle",1);
				$_GET = codeClean($_GET);

				if (!empty($_GET["section"]) && $_GET["section"] == "manufacturer") {
					$smarty->assign("manufactureredit",1);
					$smarty->assign("edit",getSingleOption($_GET["section"], $_GET["id"]));
				} elseif (!empty($_GET["section"]) && $_GET["section"] == "features") {
					$smarty->assign("featuresedit",1);
					$smarty->assign("edit",getSingleOption($_GET["section"], $_GET["id"]));
				} elseif (!empty($_GET["section"]) && $_GET["section"] == "drive_train") {
					$smarty->assign("drivetrainedit",1);
					$smarty->assign("edit",getSingleOption($_GET["section"], $_GET["id"]));
				} elseif (!empty($_GET["section"]) && $_GET["section"] == "vehicle_type") {
					$smarty->assign("vehicletypeedit",1);
					$smarty->assign("edit",getSingleOption($_GET["section"], $_GET["id"]));
				}
			//build a list of all options in a given section
			} elseif (!empty($_GET["action"]) && $_GET["action"] == "edit") {
				$smarty->assign("editlist",1);
				$_GET = codeClean($_GET);

				//if redirected from editing display a success message
				if (!empty($_GET["message"]) && $_GET["message"] == "success") {
					$smarty->assign("success",ADMIN_OPTIONS_EDIT_SUCCESS);
				}
				//if redirected after delete display a success message
				if (!empty($_GET["message"]) && $_GET["message"] == "deleted") {
					$smarty->assign("success",ADMIN_OPTIONS_DELETE_SUCCESS);
				}
				//get section then display list of data
				if (!empty($_GET["section"]) && $_GET["section"] == "manufacturer") {
					$smarty->assign("manufacturerslist",getTableDataList('manufacturer'));
				} elseif (!empty($_GET["section"]) && $_GET["section"] == "drive_train") {
					$smarty->assign("drivetrainlist",getTableDataList('drive_train'));
				} elseif (!empty($_GET["section"]) && $_GET["section"] == "vehicle_type") {
					$smarty->assign("typeslist",getTableDataList('vehicle_type'));
				} elseif (!empty($_GET["section"]) && $_GET["section"] == "features") {
					$smarty->assign("featurelist",getFeaturesList());
				}
		
			//update your options that have been entered one at a time
			} elseif (!empty($_POST["vehicle_edit"]) && $_POST["vehicle_edit"] == SAVE_CHANGES) {
				$_POST = codeClean($_POST);
				if (isset($_POST["lists_default"])) {
					$lists_default = $_POST["lists_default"];
				} else {
					$lists_default = false;
				}

				$res = updateSingleOption($_POST["table"], $_POST["option_data"], $_POST["id"], "$lists_default");
				if ($res == 99) {
					header("Location: vehicle_options.php?action=edit&section=$_POST[table]&message=success&option=$_POST[option_data]");
				}
			//delete your options one at a time
			} elseif (!empty($_POST["vehicle_delete"]) && $_POST["vehicle_delete"] == DELETE_OPTION) {
				$_POST = codeClean($_POST);
				$optionid = (int)$_POST["id"];
				$res = deleteOption($_POST["table"], $optionid);
				if ($res == 99) {
					header("Location: vehicle_options.php?action=edit&section=$_POST[table]&message=deleted&option=$_POST[option_data]");
				}
			} else {
				//section for adding new options
				if (!empty($_POST["addoption"]) && $_POST["addoption"] != "") {
					$_POST = codeClean($_POST);
					$res = addOption($_POST["option"], $_POST["table"]);
					if ($res == 99) {
						$smarty->assign("success",ADMIN_OPTIONS_ADD_NEW_OPTION_SUCCESS);
					} elseif ($res == 1){
						$smarty->assign("error_message",ADMIN_OPTIONS_ALREADY_OPTION_ERROR);
					} else {
						$smarty->assign("error_message",ADMIN_OPTIONS_BLANK_OPTION_ERROR);
					}
				}
			}
		}
	}
}

$smarty->assign("vehicle_options",1);
$smarty->display('vehicle_options.tpl');
?>