<?php
//================================================================================
// PLEASE DO NOT REMOVE THIS HEADER!!!
//
// COPYRIGHT NOTICE
// This script is licensed under the GPL
// 
// Copyright 2007-2008 Alias 454 Studios and Brandon Keep (c) All rights reserved.
// Created 11/18/2007   
// Brandon Keep,    http://www.openautoclassifieds.com
//                  http://www.alias454studios.com/scripts/
//
// Last Modified 06-14-2009 by
// Brandon Keep,    http://alias454studios.com
//================================================================================
// This software IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
// OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
//================================================================================

require_once './Includes/configs/functions.php';
require_once './Includes/libs/Smarty.class.php';

if (file_exists("./Includes/language/$site_lang/global.php")) {
	include_once "./Includes/language/$site_lang/global.php";
} else {
	include_once "./Includes/language/en/global.php";
}
if (file_exists("./Includes/language/$site_lang/".basename(__FILE__)."")) {
	include_once "./Includes/language/$site_lang/".basename(__FILE__)."";
}

$smarty = new Smarty;
$smarty->force_compile = $force_compile_enabled;

$file = basename(__FILE__, ".php");
if (file_exists("templates/$template/$file.tpl")) {
	$smarty->template_dir="templates/$template";
} else {
	$smarty->template_dir="templates/Default";
}

$smarty->assign("manufacturerslist",getSearchList("make"));
$smarty->assign("modelslist",getSearchList("model"));
$smarty->assign("typeslist",getSearchList("vehicle_type"));

//if the user is logged in let them be else redirect them to login
if (isset($_SESSION["logged_in"])){
	$smarty->assign("logged_in",1);
	$smarty->assign("username",$_SESSION["user"]);
	//check privs to find out if user 
	//is a seller, admin or user
	$status = checkPrivs();
	$smarty->assign("$status",1);

	//setup template defaults for display
	if (checkIfAdmin($_SESSION["user"],$_SESSION["pass"]) || checkIfSeller($_SESSION["user"],$_SESSION["pass"])) {
		$smarty->assign("fullmanufacturerslist",getTableDataList('manufacturer'));
		$smarty->assign("drivetrainlist",getTableDataList('drive_train'));
		$smarty->assign("typeslist",getTableDataList('vehicle_type'));		
		$smarty->assign("featurelist",getFeaturesList());
		$smarty->assign("userdetails",getUserRecords($_SESSION["user"]));
		$smarty->assign("stateslist",getStatesList());
		//$smarty->assign("max_image_count",$max_listing_image_limit);
		$smarty->assign("max_image_count",3);

		if (!empty($use_listing_approval)) {
			$smarty->assign("use_listing_approval",1);
		}

		//if post data process it accordingly
		if ($_SERVER['REQUEST_METHOD'] == 'POST') {			
			if (isset($_POST["submit"]) && $_POST["submit"] == EDIT_LISTING_FORM_UPDATE_BUTTON || isset($_POST["submit"]) == EDIT_LISTING_FORM_APPROVE_BUTTON) {
				$_POST = codeClean($_POST);
				if (!empty($_POST["features"])) {
					$implodedfeatures = implode(',', $_POST["features"]);
				} else {
					$implodedfeatures = "";
				}

				//check for seller account if one exists ok else show error
				if (!empty($_POST["seller"])) {
					$sellerid = getSellerId($_POST["seller"]);
				} else {
					$smarty->assign("error_message",NO_DEFAULT_SELLER);
				}

				//check if listing is being marked as sold 
				if (!empty($_POST["sold"])) {
					$_POST["sold"] = $_POST["sold"];
				} else {
					$_POST["sold"] = 0;
				}

				//get update listing result and procede
				$res = updateListing($_POST["id"],$_POST["ad_title"],$_POST["make"],$_POST["model"],$_POST["vehicle_type"],$_POST["doors"],$_POST["color"],$_POST["mileage"],$_POST["year"],$_POST["listing_condition"],$_POST["engine"],$_POST["trans"],$_POST["drive_train"],$_POST["mpg"],$_POST["fuel_type"],$_POST["price"],$_POST["adddesc"],$implodedfeatures,$_POST["vin"],$_POST["stock"],$_POST["city"],$_POST["state"],$_POST["zip"],$_POST["sold"],$sellerid,$_POST["seller"]);
				if (!is_array($res) && $res == 99) {
					$smarty->assign("success",EDIT_LISTING_SUCCESS);
				} else {
					//Errors during form submission	so build error list
					$content = '';
					if (in_array(1,$res)) {
						$content .= "" . EMPTY_MAKE ."<br />";
						$smarty->assign("manufacturer_error",1);
					}
					if (in_array(2,$res)) {
						$content .= "" . EMPTY_MODEL ."<br />";
						$smarty->assign("model_error",1);
					} 
					if (in_array(3,$res)) {
						$content .= "" . MILEAGE_ERROR ."<br />";
						$smarty->assign("mileage_error",1);
					} 
					if (in_array(4,$res)) {
						$content .= "" . YEAR_LENGTH_ERROR ."<br />";
						$smarty->assign("year_error",1);
					}
					if (in_array(5,$res)) {
						$content .= "" . YEAR_DIGIT_ERROR ."<br />";
						$smarty->assign("year_error",1);
					}
					if (in_array(6,$res)) {
						$content .= "" . VIN_LENGTH_ERROR ."<br />";
						$smarty->assign("vin_error",1);
					}
					if (in_array(7,$res)) {
						$content .= "" . VIN_INVALID_ERROR ."<br />";
						$smarty->assign("vin_error",1);
					}
					
					$smarty->assign("error_message",$content);
				}
			} elseif (isset($_POST["addimage"])) {
				$_POST = codeClean($_POST);
				//$_FILES = codeClean($_FILES);

				//if files array not empty perform upload operations
				if (!empty($_FILES["image"])) {
					//break down file array so we get the right info
					$image_files = array(); 
					foreach ($_FILES["image"] as $field => $array) {
						foreach ($array as $a_num => $value) {
							//print "$array -- $a_num -- $field -- $value <br />";
							if (!array_key_exists($a_num, $image_files))
								$image_files["$a_num"] = array();
					
							$image_files["$a_num"]["$field"] = $value;
						}
					}

					//we have a proper file array loop through adding the listimages and return errors
					foreach ($image_files as $file_info) {
						if (!empty($file_info["name"])) {
							$res = uploadListImage($listings_stored_path, $file_info["name"], $file_info["tmp_name"], $_POST["max"], $_POST["id"], "listing_", $_SESSION["user"]);
							if ($res == 99) {
								$success = preg_replace("!%FILENAME%!",$file_info["name"], EDIT_LISTING_UPLOAD_SUCCESS . "<br />");
							} elseif ($res == 1) {
								$error_message = preg_replace("!%MAXFILESIZE%!",$_POST["max"]/1024, EDIT_LISTING_MAX_ERROR);
								$error_message = preg_replace("!%FILENAME%!",$file_info["name"], "$error_message <br />");
							} elseif ($res == 2) {
								$error_message .= EDIT_LISTING_BAD_EXT . "<br />";
							} else {
								$error_message = preg_replace("!%FILENAME%!",$file_info["name"], EDIT_LISTING_UPLOAD_ERROR . "<br />");
							}
						}
					}
				}

				//if error or success from image res display message in template
				if (isset($error_message)) {
					$smarty->assign("error_message",$error_message);
				}
				if (isset($success)) {
					$smarty->assign("success",$success);
				}

			//lets delete the full listing on request
			} elseif (isset($_POST["delete"]) && $_POST["delete"] == EDIT_LISTING_FORM_DELETE_BUTTON) {
				$id = (int)$_POST["id"];
				$res = deleteFullListing($id);
				if ($res = 99)
					$smarty->assign("success",EDIT_LISTING_REMOVE_SUCCESS);
			} else {
				$smarty->assign("error_message",EDIT_LISTING_GENERAL_ERROR);
			}

			//check if admin or seller then do stuff accordingly
			if (checkIfAdmin($_SESSION["user"],$_SESSION["pass"])) {
				$id = (int)$_POST["id"];
				$smarty->assign("listdata",getListing($id));
				$smarty->assign("sellerslist",getSellers());
			} elseif (checkIfSeller($_SESSION["user"],$_SESSION["pass"])) {
				$sellerid = getSellerId($_SESSION["user"]);
				if (!empty($sellerid)) {
					$smarty->assign("listdata",getListing($_POST["id"],"",$sellerid));
					$smarty->assign("seller",$_SESSION["user"]);
				} 
			}

		//delete an image for your listing if you are the admin or own the listing
		} elseif (!empty($_GET["id"])) {
			if (isset($_GET["action"]) && $_GET["action"] =="delete") {
				if (isset($_GET["sellerid"])) {
					$userid = getUserId($_SESSION["user"]);
					if (checkIfAdmin($_SESSION["user"],$_SESSION["pass"]) || $_GET["sellerid"] == "$userid") {
						$_GET = codeClean($_GET);
						$res = deleteListingsImage($_GET["id"],$_GET["imageid"],$_SESSION["user"]);
						if ($res == 99) {
							$smarty->assign("success",EDIT_LISTING_DELETE_IMG_SUCCESS);
						} else {
							$smarty->assign("error_message",EDIT_LISTING_DELETE_IMG_ERROR);
						}
					} else {
				 		$smarty->assign("error_message",EDIT_LISTING_EDIT_OWN_IMG_ERROR);
					}
				}

			//mark an image as main if admin or listing owner
			} elseif (isset($_GET["action"]) && $_GET["action"] == "markmain") {
				if (isset($_GET["sellerid"])) {
					$userid = getUserId($_SESSION["user"]);
					if (checkIfAdmin($_SESSION["user"],$_SESSION["pass"]) || $_GET["sellerid"] == "$userid") {
						$_GET = codeClean($_GET);
						$res = markImageMain($_GET["id"],$_GET["imageid"],$_SESSION["user"]);
						if ($res == 99) {
							$smarty->assign("success",EDIT_LISTING_MARK_MAIN_SUCCESS);
						} else {
							$smarty->assign("error_message",EDIT_LISTING_MARK_MAIN_ERROR);
						}
					} else {
				 		$smarty->assign("error_message",EDIT_LISTING_EDIT_OWN_IMG_ERROR);
					}
				}

			//approve listing if admin
			} elseif (isset($_GET["action"]) && $_GET["action"] == "approve") {
				if (isset($_GET["sellerid"])) {
					if (checkIfAdmin($_SESSION["user"],$_SESSION["pass"])) {
						$_GET = codeClean($_GET);
						$res = approveImage($_GET["id"],$_GET["imageid"],$_SESSION["user"]);
						if ($res == 99) {
							$smarty->assign("success",EDIT_LISTING_APPROVE_IMAGE_SUCCESS);
						} else {
							$smarty->assign("error_message",EDIT_LISTING_APPROVE_IMAGE_ERROR);
						}
					} else {
				 		$smarty->assign("error_message",EDIT_LISTING_EDIT_OWN_IMG_ERROR);
					}
				}
			
			//approve full listing if quick approve and admin
			} elseif (isset($_GET["action"]) && $_GET["action"] == "quick_approve") {
				if (checkIfAdmin($_SESSION["user"],$_SESSION["pass"])) {
					$_GET = codeClean($_GET);
					$res = quickApproveFullListing($_GET["id"]);
					if ($res == 99) {
						$smarty->assign("success",EDIT_LISTING_APPROVE_LISTING_SUCCESS);
					} else {
						$smarty->assign("error_message",EDIT_LISTING_APPROVE_LISTING_ERROR);
					}
				} else {
			 		$smarty->assign("error_message",EDIT_LISTING_QUICK_APPROVE_ADMIN_ERROR);
				}
			}

			//check if admin and display template
			if (checkIfAdmin($_SESSION["user"],$_SESSION["pass"])) {
				$listingid = (int)$_GET["id"];
				$smarty->assign("listdata",getListing($listingid));
				$smarty->assign("sellerslist",getSellers());
			//check if seller and display template
			} elseif (checkIfSeller($_SESSION["user"],$_SESSION["pass"])) {
				$sellerid = getSellerId($_SESSION["user"]);
				if (!empty($sellerid)) {
					$listingid = (int)$_GET["id"];
					$smarty->assign("listdata",getListing($listingid,"",$sellerid));
					$smarty->assign("seller",$_SESSION["user"]);
				}
			} else {
				$smarty->assign("error_message",EDIT_LISTING_GENERAL_ERROR);
			}
		} else {
			//throw an error to select a listing to edit
			$smarty->assign("error_message",EDIT_LISTING_SELECT_ERROR);
		}
	} else {
		header("Location, member.php");
		exit();
	}
} else {
	header("Location: login.php");
	exit();
}

$smarty->display('editlisting.tpl');
?>