<?php
//================================================================================
// PLEASE DO NOT REMOVE THIS HEADER!!!
//
// COPYRIGHT NOTICE
// This script is licensed under the GPL
// 
// Copyright 2007-2008 Alias 454 Studios and Brandon Keep (c) All rights reserved.
// Created 04/04/2009   
// Brandon Keep,    http://www.openautoclassifieds.com/
//                  http://www.alias454studios.com/
//
// Last Modified 05-05-2009 by
// Brandon Keep,    http://alias454studios.com/
//================================================================================
// This software IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
// OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
//================================================================================
//installer check file
session_start();

function cleanUp()
{
	$_SESSION["file_lock"] = @fopen('../error.txt', 'w+');
	fclose($_SESSION["file_lock"]);

	unset($_SESSION["random_token"]);
	unset($_SESSION["file_lock"]);
	session_destroy();

	unlink('../admin/templates/templates_c/sec_token.txt');
	if (isset($_COOKIE["random_token"])) {
		//setcookie("random_token", NULL, time()-3600);
	}
}
//cleanUp();

if (isset($_SESSION["random_token"])) {
	if (isset($_COOKIE["random_token"]) && $_COOKIE["random_token"] != NULL) {
		if ($_SESSION["random_token"] == $_COOKIE["random_token"]) {
			$file_text = file_get_contents('../admin/templates/templates_c/sec_token.txt');
			if ($file_text !== $_COOKIE["random_token"] && $file_text !== $_SESSION["random_token"]) {
				//print "$_SESSION[random_token] - $_COOKIE[random_token] - $file_text";
				unset($_SESSION["random_token"]);
				setcookie("random_token", NULL, time()-3600);
				die("<h1>The installation token has been generated and the install is in progress.</h1>");
			}
		}
	} else {
		setcookie("random_token", $_SESSION["random_token"], time() + (60*60*1*1));
		//print '<META HTTP-EQUIV="Refresh" CONTENT="0;URL=index.php">';
		header("Location: index.php");
	}	
}

//setup some default values
$dbtype = "MySQLi"; //choose db type you want to connect to use MySQL, MySQLi or PostGreSQL as examples
$dbhost = "localhost";
$dbuser = "dbuser";
$dbpass = "dbpass";
$dbname = "openauto";

//require_once '../Includes/configs/functions.php';
require_once '../Includes/libs/Smarty.class.php';
require_once '../Includes/language/en/global.php';
require_once '../Includes/language/en/register.php';

//set debug for install in case we encounter errors
$setSQLDebug = 1;

function registerAdmin($user, $pass, $email, $first_name, $last_name, $phone, $alt_phone, $fax, $address, $city, $state, $zip)
{
	//todo work out better error handling routine
	if (!validateEmail($email)) {
		//return 1;
		$res .= "<li><span style=\"color:red\">". VALIDATE_EMAIL_ERROR ."</span></li>";
	} 
	if (!validateUsername($user)) {
		//return 2;
		$res .= "<li><span style=\"color:red\">". VALIDATE_USER_ERROR ."</span></li>";
	}
	if (!validatePhone($phone)) {
		//return 3;
		$res .= "<li><span style=\"color:red\">". PHONE_ERROR ."</span></li>";
	}
	if (!validateName($first_name)) {
		//return 4;
		$res .= "<li><span style=\"color:red\">". FIRST_NAME_ERROR ."</span></li>";
	}
	if (!validateName($last_name)) {
		//return 5;
		$res .= "<li><span style=\"color:red\">". LAST_NAME_ERROR ."</span></li>";
	}
	if (empty($pass)) {
		//return 6;
		$res .= "<li><span style=\"color:red\">". SUPPLY_PASSWORD ."</span></li>";
	} 
	if (empty($res)) {
		$sql = "TRUNCATE TABLE users";
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	  	// Get remote IP
		$ipaddress = ipConvertLong(getenv('REMOTE_ADDR'));
		$reg_date = date("Y-m-d H:i:s");

	  	//Encrypt password for database
	    $salt = 's+(_a*';
		$pass = md5($pass.$salt);

		$user_level = 9;
		$sql = "INSERT INTO users (ipaddress,user,pass,email,first_name,last_name,phone,alt_phone,fax,address,city,state,zip,reg_date,user_level,activated,approved) VALUES (" . $ipaddress . ", '" . $user . "','" . $pass . "', '" . $email . "', '" . $first_name . "', '" . $last_name . "', '" . $phone . "', '" . $alt_phone . "', '" . $fax . "', '" . $address . "', '" . $city . "', '" . $state . "', '" . $zip . "', '" . $reg_date . "', " . $user_level . ", 1, 1)"; 
		$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		$res = 99;
	}
	return $res;
}

function getFileList($dir)
{
	// prepare to read directory contents	
	if (is_dir($dir)) {
		if ($dh = opendir($dir)) {
			$c="0";
			while (($file = readdir($dh)) !== false) {
				if ($file != '.' && $file != '..' && $file != 'templates_c' && $file != 'cache') {
					if (filetype($dir . $file) !== "dir") {
						$files[$c]["folder"] = $file;
						//print "$file : filetype: $c <br />\n";
					++$c;
					}
				}
			}
			closedir($dh);
			return $files;
		}
	}
}

function safeInstallDir($path)
{
	$dirname = dirname($path);
	return $dirname == '/' ? '' : $dirname;
}

function checkFilePerms($path, $octal=true)
{
	if (!file_exists($path))
		return false;

	$perms = fileperms($path);
	$cut = $octal ? 2 : 3;
	return substr(decoct($perms), $cut);
}

//if upgrading to v1.5.2 run this function to convert the database structure
function returnListingForMigration()
{
	$sql = "SELECT features,id FROM listings";
	$res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());

	while ($a_row = sqlFetchArray($res)) {
		$id = $a_row["id"];
		if (unserialize($a_row["features"])) {
			$array_data = unserialize($a_row["features"]);
			$implodedfeatures = implode(',', $array_data);	
			$sql = "UPDATE listings SET features = '" . $implodedfeatures . "' WHERE id = " . $id . "";
			$update_res = sqlQuery($sql); if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
		} else {
			$content = "already converted";
		}
	}
	return $content;
}

function find_SQL_Version()
{
	if (function_exists('exec')) {
		$output = exec('mysql -V');
	} else {
		return false;
	}

	if ($output) {
		preg_match('![0-9]+\.[0-9]+\.[0-9]+!', $output, $version);
		return $version[0];
	}
}

function processUpgradeSQL($sqlFileToExecute)
{
	// Get a file into an array.  In this example we'll go through HTTP to get
	// the HTML source of a URL.
	if (preg_match("!SQL_upgrade_v1.5.2.sql!","$sqlFileToExecute")) {
		$content .= returnListingForMigration();
	}

	$lines = file_get_contents($sqlFileToExecute);
	$sql_stmt = explode(';', $lines);
	$last_stmt = end($sql_stmt);

	$content.= "<h1>Upgrading Database files for Open Auto Classifieds version " . OAC_VER . "</h1>";
	$content.= "<p>";
	// Loop through our array.
	foreach ($sql_stmt as $stmt) {
		$sql = "$stmt";
		$res = sqlQuery($sql);
		$content.= "<span style=\"color:green\"><strong>. </strong></span>";
		
		if ($stmt == $last_stmt) {
			$content.= "<span style=\"color:green\">Completed -- Update Success</span>";
		}
	}
	$content.= "</p>";
	return $content;
}

function processSQL($sqlFileToExecute) 
{
	// Load and explode the sql file
	//$sql_stmt = file($sqlFileToExecute);
	//$last_stmt = end($sql_stmt);
	//Process the sql file by statements
	
	// Load and explode the sql file
	$file = fopen($sqlFileToExecute,'r');
	$sql_file = fread($file,filesize($sqlFileToExecute));
	fclose($file);

	$sql_stmt = explode(';',$sql_file);
	$last_stmt = end($sql_stmt);

	$content.= "<h1>Installing Core database files for Open Auto Classifieds version " . OAC_VER . "</h1>";
	$content.= "<p>";
	foreach ($sql_stmt as $stmt) {
		if (strlen($stmt)>3) {
			$sql = "$stmt";
			$res = sqlQuery($sql);
			if(!empty($res)) {
				$content.= "<span style=\"color:green\"><strong>. </strong></span>";
			} else {
				$content.= "<span style=\"color:red\">Errors have been encountered during the SQL import process!</span>";
				if(sqlErrorReturn()) sqlDebug(__FILE__,__LINE__,sqlErrorReturn());
				break;
			}
	
			if ($stmt == $last_stmt) {
				$content.= "<span style=\"color:green\">Completed -- Update Success</span>";
			}
		}
	}
	$content.= "</p>";
	return "$content";
}

//setup active links per section
if (isset($_POST["zip_code"]) && $_POST["zip_code_db_install"] == "no") {
	$step_3 = true;
} elseif (isset($_POST["zip_code"]) && $_POST["zip_code_db_install"] == "yes") {
	$step_2 = true;
} elseif (isset($_POST["step_2"])) {
	$step_2 = true;
} elseif (isset($_POST["step_3"])) {
	$step_3 = true;
} else {
	$step_1 = true;
}

DEFINE("OAC_INSTALL_PATH","http://" . $_SERVER['SERVER_NAME'] ."" . safeInstallDir($_SERVER['PHP_SELF']) . "/");

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>Open Auto Classifieds Installation Script</title>
<base href="<?php print OAC_INSTALL_PATH; ?>" />

<link href="../style/style.css" rel="stylesheet" type="text/css" media="screen" />

</head>
<body>
<div id="pageContainer">
<div id="header">
</div>
  <div id="navcontainer">
    <ul id="navlist">
		<li<?php if (isset($step_1)) print " class=\"active\"";?>><a href="index.php" class="topnavlink">Step 1 -></a></li>
		<li<?php if (isset($step_2)) print " class=\"active\"";?>><a href="index.php" class="topnavlink">Step 2 -></a></li>
		<li<?php if (isset($step_3)) print " class=\"active\"";?>><a href="index.php" class="topnavlink">Step 3 -></a></li>
    </ul>
  </div>

<div style="margin:25px">
<?php

if (isset($_POST["install_admin_account"]) && $_POST["install_admin_account"] == "Create Account") {
	//Step 3 and 4
	require_once '../Includes/configs/functions.php';

	//$_POST = codeClean($_POST);
	$res = registerAdmin($_POST["user"], $_POST["pass"], $_POST["email"], $_POST["first_name"], $_POST["last_name"], $_POST["phone"], $_POST["alt_phone"], $_POST["fax"], $_POST["address"], $_POST["city"], $_POST["state"], $_POST["zip"], $_POST["agree"]);
	if ($res == 99) {
		//step 4 all done goto login
	print "<h1>Finished: Administrator Account for Open Auto Classifieds version " . OAC_VER . " Was Added</h1>";
	print "<p><span style=\"color:green\">Your admin account was setup succesfully.</span></p>";
	print "<p><span style=\"color:green\">The install of Open Auto Classifieds is complete.</span></p>";
	print "<p><span style=\"color:green\">Delete the install folder and <a href=\"../login.php\">proceede to your login page</a>.</span></p>";
	cleanUp();

	} else {
		//step 3 create admin user if error
		print "<h1>Step 3 Administrator Account for Open Auto Classifieds version " . OAC_VER . " Was NOT Added</h1>";
		print "<p><span style=\"color:red\">There was an error setting up your admin account!</span></p>";
		print "<ul>";
		print "$res";
		print "</ul>";
	?>
	<fieldset>
		<legend>Retry Step 3</legend>
			<form action="index.php" method="post" id="check">
            	<p><input id="step_3" name="step_3" type="hidden" value="1" />
				<input name="install_step_3" type="submit" value="Continue" />
                Click Continue to setup the admin user account.
                </p>
			</form>
	</fieldset>
    <?php
	}
} elseif (isset($_POST["zip_code"]) && $_POST["zip_code_db_install"] == "no" || isset($_POST["install_step_3"]) && $_POST["install_step_3"] == "Continue") {
	//step 3 install create admin user if steps 1 and steps 2 passed
	print "<h1>Step 3 Add an Administrator Account for Open Auto Classifieds version " . OAC_VER . "</h1>";
?>
<fieldset>
	<legend>Setup your Admin Account</legend>
		<form action="index.php" method="post">
			<h2>Enter your username and password details.</h2>
			<p><label for="user"><?php print USERNAME ?></label>
			<input id="user" name="user" type="text" size="30" maxlength="30" value="" />
			</p>
			<p><label for="pass"><?php print PASSWORD ?></label>
			<input id="pass" name="pass" type="password" size="30" maxlength="30" value="" />
			</p>
			<p><label for="email"><?php print EMAIL ?></label>
			<input id="email" name="email" type="text" size="35" maxlength="50" value="" />
			</p>

			<h2>Enter your personal information.</h2>
			<p><label for="first_name"><?php print FIRST_NAME ?></label>
			<input id="first_name" name="first_name" type="text" size="30" maxlength="30" value="" />
			</p>
			<p><label for="last_name"><?php print LAST_NAME ?></label>
			<input id="last_name" name="last_name" type="text" size="30" maxlength="30" value="" />
			</p>
			<p><label for="phone"><?php print PHONE ?></label>
			<input id="phone" name="phone" type="text" size="30" maxlength="30" value="" />
			</p>
			<p><label for="alt_phone"><?php print ALT_PHONE ?></label>
			<input id="alt_phone" name="alt_phone" type="text" size="30" maxlength="30" value="" />
			</p>
			<p><label for="fax"><?php print FAX ?></label>
			<input id="fax" name="fax" type="text" size="30" maxlength="30" value="" />
			</p>

			<p><input id="step_3" name="step_3" type="hidden" value="1" />
            <input name="install_admin_account" type="submit" value="Create Account" />
			</p>

			<p><?php print REQUIRED ?>
			</p>
	</form>
</fieldset>
<?php
} elseif (isset($_POST["upgrade_step_3"]) && $_POST["upgrade_step_3"] == "Continue") {
	//step 3 upgrade show completion message and give warning
	print "<h1>Finished: Open Auto Classifieds version " . OAC_VER . " Upgrade Complete</h1>";
	print "<p><span style=\"color:green\">The Upgrade of Open Auto Classifieds is complete.</span></p>";
	print "<p><span style=\"color:green\">Delete the install folder</span></p>";
	cleanUp();

} elseif (isset($_POST["zip_code"]) && $_POST["zip_code_db_install"] == "yes") {
	//step 2 for install update zip code db
	//print out progress messages
	print "<p>When the Zip Code Database Files Complete scroll down to proceede.</p>";

	include '../Includes/configs/db.inc.php';

	$content = processSQL('./SQL/install/zip_data_1.sql');
	print "$content";
	print "<p>Zip Code Database File 1 Complete.</p>";

	$content = processSQL('./SQL/install/zip_data_2.sql');
	print "$content";
	print "<p>Zip Code Database File 2 Complete.</p>";

	$content = processSQL('./SQL/install/zip_data_3.sql');
	print "$content";
	print "<p>Zip Code Database File 3 Complete.</p>";

	$content = processSQL('./SQL/install/zip_data_4.sql');
	print "$content";
	print "<p>Zip Code Database File 4 Complete.</p>";

	$content = processSQL('./SQL/install/zip_data_5.sql');
	print "$content";
	print "<p>Zip Code Database File 5 Complete.</p>";
?>
	<fieldset>
		<legend>Continue to Step 3</legend>
			<form action="index.php" method="post" id="check">
				<p>
                <input id="step_3" name="step_3" type="hidden" value="1" />
                <input name="install_step_3" type="submit" value="Continue" />
                Click Continue to setup the admin user account.
                </p>
			</form>
	</fieldset>
<?php
} elseif (isset($_POST["upgrade"]) && $_POST["upgrade"] == "Upgrade") {
	//step 2 for upgrade install db
	include '../Includes/configs/db.inc.php';

	$content = processUpgradeSQL("./SQL/upgrade/$_POST[upgrade_sql_file]");
	print "$content";
	print "$_POST[upgrade_sql_file] upgrading";

	print "<h2>Continue to the final step</h2>";
?>
	<fieldset>
		<legend>Continue to Step 3</legend>
			<form action="index.php" method="post" id="check">
				<p>
                <input id="step_3" name="step_3" type="hidden" value="1" />
                <input name="upgrade_step_3" type="submit" value="Continue" />
                Click Continue to finalize your upgrade.
                </p>
			</form>
	</fieldset>
<?php

} elseif (isset($_POST["install"]) && $_POST["install"] == "Install") {
	//step 2 for install write config file and install db
	//$_POST = codeClean($_POST);
	
	$db_file_to_write = '../Includes/configs/db.inc.php';
	// Get a file into an array.
	$lines = file($db_file_to_write);
	$lines[25] = '$dbtype = "' . $_POST["adbtype"] . '"; //choose db type you want to connect to use MySQL, MySQLi or PostGreSQL as examples' . "\n";
	$lines[26] = '$dbhost = "' . $_POST["adbhost"] . '";' . "\n";
	$lines[27] = '$dbuser = "' . $_POST["adbuser"] . '";' . "\n";
	$lines[28] = '$dbpass = "' . $_POST["adbpass"] . '";' . "\n";
	$lines[29] = '$dbname = "' . $_POST["adbname"] . '";' . "\n";
	
	$file = fopen($db_file_to_write, 'w');
	// Loop through our array,
	foreach ($lines as $line) {
		fwrite($file, $line);
		//echo "" . htmlspecialchars($line) . "<br />\n";
	}
	fclose($file);
	include '../Includes/configs/db.inc.php';
	//require_once '../Includes/configs/functions.php';

	$content = processSQL($_POST["sql_file_path"]);
	print "$content";
	print "<h2>Install Additional Zip Code Database files</h2>";
	print "<p>Install Additional Zip Code Database files. The zip code database is not required unless you plan on using the optional zip code lookup features</p>";
	print "<p>Installing the zip code database will take a little time due to the large amount of records. There are over 42,000 thousand records.</p>";
?>

	<fieldset>
		<legend>Install the US Zip Codes Database</legend>
			<form action="index.php" method="post" id="check">
				<p>
				<input type="radio" name="zip_code_db_install" value="yes" /> Yes
				<input type="radio" name="zip_code_db_install" value="no" /> No

				<input name="zip_code" type="submit" value="Install Zip Codes" /></p>
			</form>
	</fieldset>

<?php
} elseif (isset($_POST["submit"]) && $_POST["setup_check"] == "install") {
	//step 2 for fresh install
	//We are going to install a new OAC db
	print "<h1>Step 2 Perform Database System Installation for Open Auto Classifieds version " . OAC_VER . "</h1>";

	print '<fieldset>';
	print '<legend>Enter your database information</legend>';
	print '<form action="index.php" method="post" id="install-form">';

    print '<p><label for="adbtype">Database type</label>';
    print '<select id="adbtype" name="adbtype" size="1">';
	print '<option value="MySQLi" selected="selected">MySQLi (Enhanced MySQL)</option>';
    print '<option value="MySQL">MySQL</option>';
	print '</select>';
	print '</p>';

	print '<p><label for="adbhost">Database Host:</label>';
	print '<input id="adbhost" name="adbhost" type="text" size="40" maxlength="50" value="' . $dbhost . '" />';
	print '</p>';

	print '<p><label for="adbuser">Database User:</label>';
	print '<input id="adbuser" name="adbuser" type="text" size="40" maxlength="50" value="' . $dbuser . '" />';
	print '</p>';

	print '<p><label for="adbpass">Password:</label>';
	print '<input id="adbpass" name="adbpass" type="text" size="40" maxlength="50" value="' . $dbpass . '" />';
	print '</p>';

	print '<p><label for="adbname">Database Name:</label>';
	print '<input id="adbname" name="adbname" type="text" size="40" maxlength="50" value="' . $dbname . '" />';
	print '</p>';

	print '<p><input id="sql_file_path" name="sql_file_path" type="hidden" value="./SQL/install/openauto_auto.sql" />';
	print '<p><input id="step_2" name="step_2" type="hidden" value="1" />';
	print '<input name="install" type="submit" value="Install" /></p>';
	print '</form>';
	print '</fieldset>';

} elseif (isset($_POST["submit"]) && $_POST["setup_check"] == "upgrade") {
	//step 2 for upgrade
	//we are going to do an upgrade so lets do upgrade stuff
	print "<h1>Step 2 Perform Database System Upgrade to Open Auto Classifieds version " . OAC_VER . "</h1>";
	
	print '<fieldset>';
	print '<legend>Enter your database information</legend>';
	print '<form action="index.php" method="post" id="install-form">';

	$files = getFileList('./SQL/upgrade/');
	foreach ($files as $value) {
		foreach ($value as $data) {
			print '<p><input type="radio" name="upgrade_sql_file" value="' . $data . '" /> ' . $data . '</p>';
		}
	}

	print '<p><input id="step_2" name="step_2" type="hidden" value="1" />';
	print '<input name="upgrade" type="submit" value="Upgrade" /></p>';
	print '</form>';
	print '</fieldset>';

} else {
	//step 1 perform checks
	//Perform the first step in checking if OAC can even run on this system
	print "<h1>Step 1 Perform System checks for Open Auto Classifieds version " . OAC_VER . "</h1>";
	
	//check php version
	$ver = phpversion();
	if ($ver >= 5) {
		print "<p style=\"color:green\">Your version of PHP is $ver</p>";
		$procede = true;
	} else {
		print "<p style=\"color:red\">Your version of PHP is $ver. You should upgrade your php or you may run into trouble</p>";
	}

	//check if we can use fopen as it is required by the install script
	if (($file = fopen('../Includes/configs/db.inc.php', "r" )) == NULL) {
   		print "<p style=\"color:red\">It appears the function fopen() is disabled on this server.</p>";
		$procede = false;
	} else {
		fclose($file);
	}

	if (!isset($_SESSION["random_token"])) {
		$random_token = rand();
		$_SESSION["random_token"] = $random_token;
		
		$file_check_size = filesize('../admin/templates/templates_c/sec_token.txt');
		if (empty($file_check_size)) {
			//write the token to a file for checking later
			$_SESSION["file_lock"] = @fopen('../admin/templates/templates_c/sec_token.txt', 'w');
			fwrite($_SESSION["file_lock"], "$random_token");
			fclose($_SESSION["file_lock"]);
			print "<p style=\"color:green\">Your Random Security token was written to the file this will prevent anyone else from running the installer</p>";
		}
		print "<p style=\"color:green\">The Security token written previously matches your token</p>";
		print '<META HTTP-EQUIV="Refresh" CONTENT="0;URL=index.php">';
	} else {
		print "<p style=\"color:green\">Your Random Security token was written to the file this will prevent anyone else from running the installer</p>";
	}

	//check mysql version using exec()
	if (function_exists('mysql_connect')) {
		$procede = true;
		$sql_ver = find_SQL_Version();
		//check if mysqli extension is loaded
		if (function_exists('mysqli_connect')) {
			$mysqli_exists = "and the MySQLi Extensions are available";
		}
		if ($sql_ver) {
			print "<p style=\"color:green\">Your SQL version is $sql_ver $mysqli_exists</p>";
		} else {
			print "<p style=\"color:green\">MySQL is installed $mysqli_exists</p>";
		}
	} else {
		print "<p style=\"color:red\">It appears MySQL is not running on your system</p>";
	}
	
	//check gd
	if (extension_loaded('gd') && function_exists('gd_info')) {
		$procede = true;
		print "<p style=\"color:green\">It looks like GD is installed</p>";
		print "<pre>";
	
		$gd = gd_info();
		foreach ($gd as $key => $value) {
			if ($key == 'WBMP Support')
				break;
			
			print " " . $key . ": ";
			if ($value) {
				if ($key == 'GD Version') {
					print "<span style=\"color:green\">$value</span> <br />";
				} else {
					print "<span style=\"color:green\">Yes</span> <br />";
				}
			} else {
				print "<span style=\"color:red\">NO</span> <br />";
			}
		}
		print "</pre>";
	} else {
		print "<p style=\"color:red\">GD support is needed to allow dynamic display of listing images, and profile images</p>";
		$procede = false;
	}
	
	//check register globals is off
	if (ini_get('register_globals')) {
		print "<p style=\"color:red\">Registor globals is ON</a><br />This is a security issue, please change settings inside your php.ini file</p>";
		$procede = false;
	} else {
		print "<p style=\"color:green\">Register globals is OFF</p>";
		$procede = true;
	}

	//file we are going to check the permissions on
	$files_check_array[] = ("../admin/templates/templates_c");
	$files_check_array[] = ("../admin/templates/cache");
	$files_check_array[] = ("../templates/templates_c");
	$files_check_array[] = ("../templates/cache");
	$files_check_array[] = ("../images/users");
	$files_check_array[] = ("../images/listings");
	$files_check_array[] = ("../error.txt");
	$files_check_array[] = ("../Includes/configs/db.inc.php");

	print "<p>";
	foreach ($files_check_array as $value) {
		//check file from array is writable
		$print_value = str_replace('../', '', $value);
		print "$print_value";
		$res = checkFilePerms("$value");
		if ($res == 777 || $res == 755 || $res == 666 || $res == 644 ) {
			print " <span style=\"color:green\">is writable</span>";
			$procede = true;
		} else {
			print " <span style=\"color:red\">is not writable</span>";
			$procede = false;
		}
		print "<br />";
	}
	print "</p>";

	//above checks passed so lets get to work
	if ($procede) {
	?>
	<fieldset>
		<legend>Perform an Install or an Upgrade</legend>
			<form action="index.php" method="post" id="check">
				<p>
				<input type="radio" name="setup_check" value="upgrade" /> Upgrade
				<input type="radio" name="setup_check" value="install" /> Install

                <input id="step_2" name="step_2" type="hidden" value="1" />
				<input name="submit" type="submit" value="Submit" /></p>
			</form>
	</fieldset>
	
	<?php
	//above checks failed we have to fix it
	} else {
		print "There is a problem check your configuration before proceeding!";
	}

}
?>
</div>
<div id="footer">
	<div id="bottomcontainer">
		<div class="boxlt">
			<p><?php print POWERED_BY ?></p>
		</div>
		<div class="boxrt">
			<p><?php print COPYRIGHT ?> <a href="http://openautoclassifieds.com">Open Auto Classifieds</a></p>
		</div>

	</div>
</div>
</div>
</body>
</html>