<?php
//================================================================================
// PLEASE DO NOT REMOVE THIS HEADER!!!
//
// COPYRIGHT NOTICE
// This script is licensed under the GPL
// 
// Copyright 2007-2008 Alias 454 Studios and Brandon Keep (c) All rights reserved.
// Created 11/18/2007   
// Brandon Keep,    http://www.openautoclassifieds.com
//                  http://www.alias454studios.com/scripts/
//
// Last Modified 06-24-2009 by
// Brandon Keep,    http://alias454studios.com
//================================================================================
// This software IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
// OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.
//================================================================================

require_once './Includes/configs/functions.php';
require_once './Includes/libs/Smarty.class.php';
require_once './Includes/libs/SmartyPaginate.class.php';
require_once './Includes/libs/zipcode.class.php';

if (file_exists("./Includes/language/$site_lang/global.php")) {
	include_once "./Includes/language/$site_lang/global.php";
} else {
	include_once "./Includes/language/en/global.php";
}
if (file_exists("./Includes/language/$site_lang/".basename(__FILE__)."")) {
	include_once "./Includes/language/$site_lang/".basename(__FILE__)."";
}

$smarty = new Smarty;
$smarty->force_compile = $force_compile_enabled;

$file = basename(__FILE__, ".php");
if (file_exists("templates/$template/$file.tpl")) {
	$smarty->template_dir="templates/$template";
} else {
	$smarty->template_dir="templates/Default";
}
//$smarty->template_dir="templates/$template";

$paginate = new SmartyPaginate();

$smarty->assign("manufacturerslist",getSearchList("make"));
$smarty->assign("modelslist",getSearchList("model"));
$smarty->assign("typeslist",getSearchList("vehicle_type"));

//Check if single user mode 1 or multi-user mode 0
if ($site_mode == 0) {
	$smarty->assign("site_mode",1);
}

//if the user is logged in let them be else redirect them to login
if (isset($_SESSION["logged_in"])) {
	$smarty->assign("logged_in",1);
	$smarty->assign("username",$_SESSION["user"]);
	//check privs to find out if user 
	//is a seller, admin or user
	$status = checkPrivs();
	$smarty->assign("$status",1);
}

if (isset($_SESSION["admin"]) || isset($_SESSION["seller"])) {
	//$smarty->assign("listdata",getListing());
	$seller = '';
	if (isset($_SESSION["seller"])) {
		$seller = getSellerId($_SESSION["user"]);
	}
	$smarty->assign("userdetails",getUserRecords($_SESSION["user"]));
} else {
	$seller = '';
}

//set default parameters for queries
$id = 'all';
$sort = '';

//search query builder below. Will build a query string for all $_POST search items
if (isset($_POST["submit"]) && $_POST["submit"] == SEARCH) {
	$_POST = codeClean($_POST);
	$paginate->disconnect();
	$addOnSQL = '';

	if (!empty($_POST["min_price"])) {
		if (!empty($addOnSQL))
			$addOnSQL.=" AND ";
		$addOnSQL.="price >= '" . number_format($_POST["min_price"], 2, CURRENCY_SYMBOLS_DECIMAL_SEPARATOR, '') . "'";
	}
	if (!empty($_POST["max_price"])) {
		if (!empty($addOnSQL))
			$addOnSQL.=" AND ";
		$addOnSQL.="price <= '" . number_format($_POST["max_price"], 2, CURRENCY_SYMBOLS_DECIMAL_SEPARATOR, '') . "'";
	}
	if (!empty($_POST["start_zip"])) {
		$zip = new zipcode_class;
		if (!empty($addOnSQL))
			$addOnSQL.=" AND ";
		if (!empty($_POST["zip_range"]))
			$zips = $zip->get_zips_in_range($_POST["start_zip"], $_POST["zip_range"], _ZIPS_SORT_BY_DISTANCE_ASC, true); 
		if (empty($zips)) {
			$addOnSQL.="zip = " . $_POST["start_zip"] . "";
		} else {
			// this fetches all the zip codes in the $zips variable
			$zipcodes = array_keys($zips); 
			$zip_list = implode(",",$zipcodes); 
			$addOnSQL.="zip IN (" . $zip_list . ")";
		}
	}
	if (!empty($_POST["state"])) {
		if (!empty($addOnSQL))
			$addOnSQL.=" AND ";
		$addOnSQL.="state = '" . $_POST["state"] . "'";
	}	
	if (!empty($_POST["vehicle_type"])) {
		if (!empty($addOnSQL))
			$addOnSQL.=" AND ";
		$addOnSQL.="vehicle_type = '" . $_POST["vehicle_type"] . "'";
	}	
	if (!empty($_POST["make"])) {
		if (!empty($addOnSQL))
			$addOnSQL.=" AND ";
		$addOnSQL.="make = '" . $_POST["make"] . "'";
	}
	if (!empty($_POST["makeIndexList"])) {
		if (!empty($addOnSQL))
			$addOnSQL.=" AND ";
		$addOnSQL.="make = '" . $_POST["makeIndexList"] . "'";
	}
	if (!empty($_POST["makeSideList"])) {
		if (!empty($addOnSQL))
			$addOnSQL.=" AND ";
		$addOnSQL.="make = '" . $_POST["makeSideList"] . "'";
	}
	if (!empty($_POST["model"])) {
		if (!empty($addOnSQL))
			$addOnSQL.=" AND ";
		$addOnSQL.="model = '" . $_POST["model"] . "'";
	}
	if (!empty($_POST["modelSideList"])) {
		if (!empty($addOnSQL))
			$addOnSQL.=" AND ";
		$addOnSQL.="model = '" . $_POST["modelSideList"] . "'";
	}
	if (!empty($_POST["modelIndexList"])) {
		if (!empty($addOnSQL))
			$addOnSQL.=" AND ";
		$addOnSQL.="model = '" . $_POST["modelIndexList"] . "'";
	}
	if (!empty($_POST["year"])) {
		if (!empty($addOnSQL))
			$addOnSQL.=" AND ";
		$addOnSQL.="year = '" . $_POST["year"] . "'";
	}
	if (!empty($_POST["listing_condition"])) {
		if (!empty($addOnSQL))
			$addOnSQL.=" AND ";
		$addOnSQL.="listing_condition = '" . $_POST["listing_condition"] . "'";
	}
	if (!empty($_POST["trans"])) {
		if (!empty($addOnSQL))
			$addOnSQL.=" AND ";
		$addOnSQL.="trans = '" . $_POST["trans"] . "'";
	}
	if (!empty($_POST["drive_train"])) {
		if (!empty($addOnSQL))
			$addOnSQL.=" AND ";
		$addOnSQL.="drive_train = '" . $_POST["drive_train"] . "'";
	}
	if (!empty($_POST["sellerid"])) {
		if (!empty($addOnSQL))
			$addOnSQL.=" AND ";
		$addOnSQL.="sellerid = '" . $_POST["sellerid"] . "'";
	}
	if (!empty($_POST["features"])) {
		if (!empty($addOnSQL))
			$addOnSQL.=" AND ";

		$featureslist = $_POST["features"];
		$count = count($featureslist);

		$c=0;
		foreach($featureslist as $key => $id) {
			$addOnSQL.="features LIKE '%,".$id.",%' OR features LIKE '".$id.",%' OR features LIKE '%,".$id."' OR features LIKE '".$id."'";
			if ($c == $count-1) {
				break;
			} else {
				$addOnSQL.=" OR ";
			}
			++$c;
		}
	}

	//Check for empty search Set to display all listings
	if (empty($addOnSQL)) {
		$id = 'all';
		$addOnSQL = '';
	} else {
		//assign db results to the template getListing($id='all', $addOnSQL="", $sellerid="", $sort="")
		$_SESSION["addOnSQL"] = $addOnSQL;
		$id = 'search';
	}
//search query builder below. Will build a query string for $_GET search items
} elseif (isset($_GET["action"]) && $_GET["action"] == "find") {
	$_GET = codeClean($_GET);
	$paginate->disconnect();
	$addOnSQL = '';

	if (!empty($_GET["make"])) {
		if (!empty($addOnSQL))
			$addOnSQL.=" AND ";
		$_GET["make"] = str_replace('-', '_', $_GET["make"]);
		$addOnSQL.="make LIKE '" . $_GET["make"] . "'";
	}
	if (!empty($_GET["model"])) {
		if (!empty($addOnSQL))
			$addOnSQL.=" AND ";
		$_GET["model"] = str_replace('-', '_', $_GET["model"]);
		$addOnSQL.="model LIKE '" . $_GET["model"] . "'";
	}
	if (!empty($_GET["condition"])) {
		if (!empty($addOnSQL))
			$addOnSQL.=" AND ";
		$addOnSQL.="listing_condition LIKE '" . $_GET["condition"] . "%'";
	}

	//Check for empty search Set to display all listings
	if (empty($addOnSQL)) {
		$id = 'all';
		$addOnSQL = '';
	} else {
		//assign db results to the template getListing($id='all', $addOnSQL="", $sellerid="", $sort="")
		$_SESSION["addOnSQL"] = $addOnSQL;
		$listing_category = true;
		$id = 'search';
	}
//query builder for view all sellers items
} elseif (isset($_GET["sellerid"])) {
	$sellerid = (int)$_GET["sellerid"];
	$paginate->disconnect();
	$addOnSQL = '';
	
	if (!empty($sellerid)) {
		if (!empty($addOnSQL))
			$addOnSQL.=" AND ";
		$addOnSQL.="sellerid = " . $sellerid . "";
	}
	
	//print "$addOnSQL";
	$_SESSION["addOnSQL"] = $addOnSQL;
	//assign db results to the template getListing($id='all', $addOnSQL="", $sellerid="", $sort="")
	$id = 'search';

} elseif (isset($_GET["next"])) {
	$paginate->disconnect();
	$sort = '';

	//assign db results to the template getListing($id='all', $addOnSQL="", $sellerid="", $sort="")
	if (isset($_SESSION["addOnSQL"])) {
		$id = 'search';
		$addOnSQL = $_SESSION["addOnSQL"];
		if (!empty($_SESSION["sort"])) {
			$sort = $_SESSION["sort"];
		}
	} else {
		$id = 'all';
		$addOnSQL = '';
		if (!empty($_SESSION["sort"])) {
			$sort = $_SESSION["sort"];
		}
	}
} elseif (isset($_GET["action"]) && $_GET["action"] == "view") {
	$paginate->disconnect();
	unset($_SESSION["addOnSQL"]);
	unset($_SESSION["sort"]);
	unset($_SESSION["listing_category"]);
	$id = 'all';
	$addOnSQL = '';
}

// Sort function by price model or by year
if (isset($_GET["action"]) && $_GET["action"] == "sort") {
	unset($_SESSION["sort"]);
	$sort = '';

	switch($_GET["type"]) {
		case 'model':
			if (isset($_GET["ASC"])) {
				$_SESSION["sort"] = "ORDER BY vehicle_type ASC";
			} elseif (isset($_GET["DESC"])) {
				$_SESSION["sort"] = "ORDER BY vehicle_type DESC";
			}
			break;
		case 'year':
			if (isset($_GET["ASC"])) {
				$_SESSION["sort"] = "ORDER BY year ASC";
			} elseif (isset($_GET["DESC"])) {
				$_SESSION["sort"] = "ORDER BY year DESC";
			}
			break;
		case 'price':
			if (isset($_GET["ASC"])) {
				$_SESSION["sort"] = "ORDER BY price ASC";
			} elseif (isset($_GET["DESC"])) {
				$_SESSION["sort"] = "ORDER BY price DESC";
			}
			break;
		default:
			$_SESSION["sort"] = "ORDER BY id DESC";
			break;
	}
	$sort = $_SESSION["sort"];

	if (!empty($use_fancy_urls)) {
		header('Location: next/1/');
	} else {
		header('Location: listings.php?next=1');
	}
}

if (isset($_GET["id"])) {
	$_GET = codeClean($_GET);
	$singleSQL = '';
	$id = (int)$_GET["id"];

	if (!empty($_GET["make"])) {
		if (!empty($singleSQL))
			$singleSQL.=" AND ";
		$_GET["make"] = str_replace('-', '_', $_GET["make"]);
		$singleSQL.="make LIKE '" . $_GET["make"] . "'";
	}
	if (!empty($_GET["model"])) {
		if (!empty($singleSQL))
			$singleSQL.=" AND ";
		$_GET["model"] = str_replace('-', '_', $_GET["model"]);
		$singleSQL.="model LIKE '" . $_GET["model"] . "'";
	}
	if (!empty($id)) {
		if (!empty($singleSQL))
			$singleSQL.=" AND ";
		$singleSQL.="id = " . $id . "";
	}
	$singleSQL = str_replace('-', ' ', $singleSQL);

	if (!empty($id)) {
		updateHitCounter($id);
	}

	$listingdata = getListing($id,$singleSQL);
	$sellerinfo = getUserDetails($listingdata[0]["sellerid"]);

	$smarty->assign("singlelistdata",$listingdata);
	$smarty->assign("sellerinfo",$sellerinfo);
	
	$file = $sellerinfo[0]["image"];
	if (!empty($file)) {
		$ext_split = explode('.', $file);
		$ext = $ext_split[1];
		$base = $ext_split[0];
	
		$smarty->assign("thumb","$base" . "_thumb" . "." . "$ext");
	}
	$smarty->assign("featurelist",getFeaturesList());
	$smarty->assign("viewsingle",1);
	
	if (isset($_GET["largeIMG"])) {
		$_GET = codeClean($_GET);
		$largeIMG = $_GET["largeIMG"];
		$smarty->assign("largeIMG","$largeIMG");
	}

	unset($_SESSION["listing_category"]);

	//set to display tabs on listings.tpl
	if (!empty($use_tab_display)) {
			$smarty->assign("use_tab_display",1);
	}

} else {
	//required connect for pagination
	$paginate->connect();

	//check if the addon sql has been set
	if (!isset($addOnSQL)) {
		$addOnSQL = '';
	}

	//set dynamic items per page
	if (isset($_POST["dynamic_listings_per_page"])) {
		$listings_per_page = (int)$_POST["dynamic_listings_per_page"];
		unset($_SESSION["listings_per_page"]);
		$_SESSION["listings_per_page"] = $listings_per_page;
		
		if (!empty($use_fancy_urls)) {
			header('Location: listings/action/view/');
		} else {
			header('Location: listings.php?next=1');
		}
	}

	if (isset($_SESSION["listings_per_page"])) {
		$listings_per_page = $_SESSION["listings_per_page"];
	}

	$smarty->assign("$listings_per_page",$listings_per_page);

	$paginate->setLimit($listings_per_page);
	$paginate->setPageLimit(15);

	$smarty->assign("listdata",getListing($id,$addOnSQL,$seller,$sort));
	//assign {$paginate} var
	$paginate->assign($smarty);
}

if (isset($listing_category)) {
	$_SESSION["listing_category"] = $listing_category;
	$smarty->assign("listing_category",1);	
} elseif (isset($_SESSION["listing_category"])) {
	$smarty->assign("listing_category",1);
}

if ($use_lightbox_display) {
	$smarty->assign("use_lightbox_display",1);
}

if ($use_fancy_urls) {
	$smarty->assign("use_fancy_urls",1);
}

$smarty->assign("listings",1);
$smarty->display('listings.tpl');
?>